#region Copyright

// ADS - Autonomous Aerial Drone Simulator
// http://anjdreas.spaces.live.com/
//  
// A Master of Science thesis on autonomous flight at the 
// Norwegian University of Science and Technology (NTNU).
//  
// Copyright  2009-2010 by Andreas Larsen.  All rights reserved.

#endregion

#region Using

using Microsoft.Xna.Framework;

#endregion

namespace Anj.Helpers.XNA
{
    public struct Axes
    {
        public Vector3 Forward, Right, Up;

        public Axes(Vector3 forward, Vector3 right, Vector3 up)
        {
            Forward = forward;
            Right = right;
            Up = up;
        }

        public static Axes operator +(Axes lh, Axes rh)
        {
            return new Axes(
                lh.Forward + rh.Forward,
                lh.Right + rh.Right,
                lh.Up + lh.Up);
        }

        public static Axes operator -(Axes lh, Axes rh)
        {
            return new Axes(
                lh.Forward - rh.Forward,
                lh.Right - rh.Right,
                lh.Up - lh.Up);
        }

        public override string ToString()
        {
            return Right + " - " + Up + " - " + Forward;
        }
    }
}