﻿#region Copyright

// A²DS - Autonomous Aerial Drone Simulator
// http://anjdreas.spaces.live.com/
//  
// A Master of Science thesis on autonomous flight at the 
// Norwegian University of Science and Technology (NTNU).
//  
// Copyright © 2009-2010 by Andreas Larsen.  All rights reserved.

#endregion

#region Using

using System;

#endregion

namespace Anj.Helpers.XNA
{
    public class GaussianRandom
    {
        private readonly Random _rand;

        public GaussianRandom()
        {
            _rand = new Random();
        }

        /// <summary>
        ///   Copied from: http://stackoverflow.com/questions/218060/random-gaussian-variables
        /// </summary>
        /// <param name="mean"></param>
        /// <param name="stdDev"></param>
        /// <returns></returns>
        public float NextGaussian(double mean, double stdDev)
        {
            double u1 = _rand.NextDouble(); //these are uniform(0,1) random doubles
            double u2 = _rand.NextDouble();

            //random normal(0,1)
            double randStdNormal = Math.Sqrt(-2.0*Math.Log(u1))*Math.Sin(2.0*Math.PI*u2);

            //random normal(mean,stdDev^2)
            double randNormal = mean + stdDev*randStdNormal;

            return (float) randNormal;
        }
    }
}